51 Commits

Author SHA1 Message Date
星光-k
08745ea6d4 Add files via upload 2025-01-15 18:19:47 +00:00
星光-k
742c46f4f2 Add files via upload 2025-01-15 14:14:36 +00:00
星光-k
256d2fd2cc 更新 main.py 2025-01-14 22:08:45 +00:00
星光-k
eca6a07273 更新 clean.py 2025-01-14 22:04:36 +00:00
星光-k
e37bdcc9bf 更新 clean.py 2025-01-14 22:02:57 +00:00
星光-k
4f3d04f357 更新 clean.sh 2025-01-14 17:14:01 +00:00
星光-k
d6715fa5d3 更新 clean.sh 2025-01-14 17:02:43 +00:00
星光-k
ff6995de24 更新 main.py 2025-01-14 16:44:33 +00:00
星光-k
4d675b55af Create info-clean.log 2025-01-15 00:29:41 +08:00
星光-k
f002a2fc9b Create info.log 2025-01-15 00:29:20 +08:00
星光-k
7597b2a35f 更新 start.sh 2025-01-14 16:27:45 +00:00
星光-k
533374daa3 Delete log directory 2025-01-14 19:17:26 +08:00
星光-k
531f5a443b Update clean.sh 2025-01-14 19:16:16 +08:00
星光-k
e1a0fdaa34 Update start.sh 2025-01-14 19:16:01 +08:00
星光-k
d5224e81cc Update main.py 2025-01-14 19:15:46 +08:00
星光-k
a9021dc262 Update start.sh 2025-01-14 16:50:31 +08:00
星光-k
2485a83f2c 更新 install.sh 2025-01-14 02:45:34 +00:00
星光-k
0b7f6c4dfc Update README.md 2025-01-14 09:14:02 +08:00
星光-k
bca24803a5 Update install.sh 2025-01-14 08:10:10 +08:00
星光-k
75528eba1c Update install.sh 2025-01-14 07:54:48 +08:00
星光-k
b159a7a402 Update install.sh 2025-01-14 07:36:03 +08:00
星光-k
c5c7b055e3 Update install.sh 2025-01-14 07:30:06 +08:00
星光-k
69d32309a7 Update install.sh 2025-01-14 07:28:03 +08:00
星光-k
cb89e6cd5c Update install.sh 2025-01-14 07:22:45 +08:00
星光-k
902c237010 Update install.sh 2025-01-14 07:06:03 +08:00
星光-k
20f8a5a181 Update install.sh 2025-01-14 07:03:34 +08:00
星光-k
fa4c0e5a9e Update install.sh 2025-01-14 06:57:24 +08:00
星光-k
c35ec31440 Update main.py 2025-01-14 06:37:01 +08:00
星光-k
9d76efe6ee 更新 clean.py 2025-01-13 21:44:19 +00:00
星光-k
f4752268e8 更新 main.py 2025-01-13 20:32:24 +00:00
星光-k
90ae8aab3d 更新 main.py 2025-01-13 19:51:19 +00:00
星光-k
3a3407c735 更新 main.py 2025-01-13 19:39:31 +00:00
星光-k
a4f140966a 更新 start.sh 2025-01-13 19:10:21 +00:00
星光-k
d0adc8b213 更新 start.sh 2025-01-13 19:04:01 +00:00
星光-k
21f637f1cf 更新 start.sh 2025-01-13 18:54:20 +00:00
星光-k
bebbbc554c 更新 start.sh 2025-01-13 18:46:44 +00:00
星光-k
c8419c2fe8 更新 start.sh 2025-01-13 18:45:30 +00:00
星光-k
9ec0b39b16 更新 start.sh 2025-01-13 18:40:33 +00:00
星光-k
6ec682cb1a 更新 start.sh 2025-01-13 18:40:06 +00:00
星光-k
a9809e68f1 更新 clean.sh 2025-01-13 18:05:33 +00:00
星光-k
67fd8f3c2d 更新 clean.sh 2025-01-13 18:05:03 +00:00
星光-k
e4802e0ee4 更新 clean.sh 2025-01-13 18:04:52 +00:00
星光-k
b3feb79540 更新 start.sh 2025-01-13 17:50:01 +00:00
星光-k
5aed29edac 更新 start.sh 2025-01-13 17:22:29 +00:00
星光-k
ac7c8b2378 更新 install.sh 2025-01-13 17:18:01 +00:00
星光-k
ee5d2bb1ba 更新 start.sh 2025-01-13 16:25:50 +00:00
星光-k
0d849f7a7e 更新 start.sh 2025-01-13 15:24:46 +00:00
星光-k
78f7f9b597 更新 clean.sh 2025-01-13 14:45:09 +00:00
星光-k
4baaf25d44 更新 start.sh 2025-01-13 14:43:04 +00:00
星光-k
a2df4e6162 Update clean.sh 2025-01-13 18:57:49 +08:00
星光-k
f0541b1ee0 更新 clean.sh 2025-01-13 09:16:40 +00:00
8 changed files with 230 additions and 52 deletions

View File

@@ -68,6 +68,7 @@ sudo reboot
--gitcn 克隆中国仓库
--pisugar-wifi-conf 安装pisugar-wifi-conf
--pisugar-power-manager 安装pisugar-power-manager
--version <tag> 版本号
--debug 输出详细信息
```
###
@@ -77,7 +78,7 @@ curl -sSL https://gitee.com/xingguangk/2.13-Ink-screen-clock/raw/main/bin/instal
```
```Bash
#中国源全参数设置(不使用--debug参数)
curl -sSL https://gitee.com/xingguangk/2.13-Ink-screen-clock/raw/main/bin/install.sh | sudo bash -s -- --zh --cn --gitcn --pisugar-power-manager --pisugar-wifi-conf
curl -sSL https://gitee.com/xingguangk/2.13-Ink-screen-clock/raw/main/bin/install.sh | sudo bash -s -- --version <tag> --zh --cn --gitcn --pisugar-power-manager --pisugar-wifi-conf
```
```Bash
#默认源默认设置
@@ -85,7 +86,7 @@ curl -sSL https://github.com/kxgx/2.13-Ink-screen-clock/raw/main/bin/install.sh
```
```Bash
#默认源全参数设置(不使用--debug参数)
curl -sSL https://github.com/kxgx/2.13-Ink-screen-clock/raw/main/bin/install.sh | sudo bash -s -- --zh --cn --gitcn --pisugar-power-manager --pisugar-wifi-conf
curl -sSL https://github.com/kxgx/2.13-Ink-screen-clock/raw/main/bin/install.sh | sudo bash -s -- --version <tag> --zh --cn --gitcn --pisugar-power-manager --pisugar-wifi-conf
```
## 需要安装的软件和依赖:

View File

@@ -34,11 +34,13 @@ def clear_screen():
epd.Clear(0xFF)
# 等待一段时间,确保清除操作完成
time.sleep(1)
#time.sleep(1)
# 将屏幕置于睡眠模式
logging.info("Putting e-Paper display to sleep")
epd.sleep()
epd2in13_V4.epdconfig.module_exit(cleanup=True)
exit()
logging.info("e-Paper display cleared successfully")

View File

@@ -2,9 +2,9 @@
f_name="clean.py"
dir=$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )
logdir="${dir}/log"
logdir="${dir%/*}/log"
service_name="raspi_e-Paper.service"
hold_time_seconds=3 # 设置维持时间例如300秒5分钟
hold_time_seconds=5 # 设置维持时间例如300秒5分钟
# 停止raspi_e-Paper服务
echo "正在停止$service_name服务..."

159
bin/clock.py Normal file
View File

@@ -0,0 +1,159 @@
#!/usr/bin/env python
# -*- coding:utf-8 -*-
from PIL import Image,ImageDraw,ImageFont #引入图片处理库
import os,sys,re,json,time,datetime #引入系统相关库
from borax.calendars.lunardate import LunarDate #农历日期以及天干地支纪年法的 Python 库
import logging #日志库
import subprocess
import os
from threading import Timer
import requests
white = 255 #颜色
black = 0
logging.basicConfig(level=logging.DEBUG)
################################引入配置文件开始################################################
picdir = os.path.join(os.path.dirname(os.path.dirname(os.path.realpath(__file__))), 'pic')
libdir = os.path.join(os.path.dirname(os.path.dirname(os.path.realpath(__file__))), 'lib')
if os.path.exists(libdir):
sys.path.append(libdir)#将引入文件添加到环境变量
from waveshare_epd import epd2in13_V4 #引入墨水屏驱动文件
logging.debug("Loading Fonts")
font01 = ImageFont.truetype(os.path.join(picdir, 'Font.ttc'), 20) #字体文件
font02 = ImageFont.truetype(os.path.join(picdir, 'Font.ttc'), 15) #字体文件
font03 = ImageFont.truetype(os.path.join(picdir, 'DSEG7Modern-Bold.ttf'), 38) #字体文件
font04 = ImageFont.truetype(os.path.join(picdir, 'Font.ttc'), 10) #字体文件
font05 = ImageFont.truetype(os.path.join(picdir, 'Font.ttc'), 12) #字体文件
font06 = ImageFont.truetype(os.path.join(picdir, 'Font.ttc'), 13) #字体文件
################################引入配置文件结束################################################
def Local_strong_brush(): #局部强制刷新显示
i = 0
while i < 5:
epd.displayPartial(epd.getbuffer(info_image.rotate(180)))#局刷开始
i = i + 1
def get_date():#返回当前年月日及星期几
date = datetime.datetime.now()
today=LunarDate.today()
week_day_dict = {0: '星期一',1: '星期二',2: '星期三',3: '星期四',4: '星期五',5: '星期六',6: '星期日',}
day = date.weekday()
return time.strftime('%Y年%m月%d')+' '+week_day_dict[day]+' '+today.strftime('%M月%D')
def get_time():#返回当前时间,不到秒,大写
return time.strftime('%H:%M')
def Get_address():#获取当前的IP地址
return (subprocess.check_output(u"hostname -I | cut -d\' \' -f1 | head --bytes -1", shell = True ).decode('gbk'))
def CPU_temperature():#CPU温度获取
temperatura = os.popen('vcgencmd measure_temp').readline()
temperatura = temperatura.replace('temp=','').strip()
return str(temperatura)
def Memory_footprint():#显示内存占用百分比
return(subprocess.check_output(u"free -m | awk -F '[ :]+' 'NR==2{printf \"%d\", ($3)/$2*100}'", shell = True ).decode('gbk'))
def CPU_usage(): #显示CPU占用百分比
return(str(int(float(os.popen("top -b -n1 | awk '/Cpu\(s\):/ {print $2}'").readline().strip()))))
def power_battery():#获取当前电池电量
return(str(int(subprocess.check_output(u"echo \"get battery\" | nc -q 0 127.0.0.1 8423|awk -F':' '{print int($2)}'", shell = True ).decode('gbk')))+u'%')
# 打印电量信息
print(power_battery())
def Bottom_edge(): #在图片中添加底边内容
draw.rectangle((0, 105, 250, 122), 'black', 'black')
'''电池图标画图'''
draw.line((126,109,154,109),fill=255, width=1) #电池顶边
draw.line((126,110,126,119),fill=255, width=1) #电池左边
draw.line((127,119,154,119),fill=255, width=1) #电池下边
draw.line((154,110,154,118),fill=255, width=1)
draw.line((155,112,157,112),fill=255, width=1)
draw.line((155,116,157,116),fill=255, width=1)
draw.line((157,113,157,115),fill=255, width=1)
global power_str
power_str=power_battery()
draw.text((128,108),power_str,font = font04,fill =255) #显示当前电量百分比
'''电池图标画图'''
draw.ellipse((192, 107, 207, 120), 0, 255)# 时钟图标
draw.line((199,109,199,114),fill=255, width=1)
draw.line((200,114,204,114),fill=255, width=1)
global local_addr #获取当前IP地址
local_addr= Get_address() #获取当前IP地址
draw.text((10,107),"IP:"+local_addr,font = font05,fill =255)#显示当前IP地址
def Basic_refresh(): #全刷函数
logging.info("Refresh and prepare the basic content before starting the canvas")#开始画布前刷新准备基础内容
global get_date_var
get_date_var=get_date() #记录开始数据
draw.text((2,2),get_date_var,font = font02,fill =0)#将日期及星期几显示到屏幕
global local_time
local_time=get_time()
draw.text((5,40),local_time,font = font03,fill =0)#显示当前时间
Bottom_edge() #添加底边内容
epd.display(epd.getbuffer(info_image.rotate(180)))
def Partial_full_brush(): #局部定时全刷函数
Basic_refresh() #全局刷新
logging.debug("局部定时全局刷新")
epd.init()
def Partial_refresh():#局刷函数
logging.info("Partial content update, this update is recommended to be synchronized with the minute to save the life of the ink screen")#局部内容更新,此更新建议与分钟同步,以节省墨水屏寿命
epd.displayPartBaseImage(epd.getbuffer(info_image.rotate(180)))
epd.init()
while (True):
global local_time
local_time1=get_time()
if (local_time1==local_time) ==False:
draw.rectangle((5, 40, 133, 82), fill = 255) #时间局刷区域
draw.text((5,40),local_time1,font = font03,fill =0)#刷新当前时间
local_time=local_time1
Local_strong_brush() #局部强刷
get_date_var1=get_date() #局刷判断,如果时间与前一次不一致说明内容变化,需要刷新显示
global get_date_var #再次声明这个是全局变量
if(get_date_var1==get_date_var) ==False:
draw.rectangle((2, 2, 250, 16), fill = 255) #设置头部刷新区域
draw.text((2,2),get_date_var1,font = font02,fill =0)#将日期及星期几刷新显示到屏幕
get_date_var=get_date_var1 #将更新的值保存到初始变量,直到下一次变化时执行该刷新操作
logging.debug("头部日期部位发生刷新变化.")
Local_strong_brush() #局部强刷
global local_addr #当前IP地址
local_addr1 = Get_address()
if (local_addr1==local_addr) ==False:
draw.rectangle((1, 107, 94, 120), fill = 0) #设置头部刷新区域
draw.text((10,107),"IP:"+local_addr1,font = font05,fill =255)#显示当前IP地址
local_addr=local_addr1
Local_strong_brush() #局部强刷
#显示当前电量百分比
power_str=power_str1
Local_strong_brush() #局部强刷
logging.info("电源电量局部刷新")
try:
##################屏幕初始化#########################
getWeath()#天气获取函数开始运行
epd = epd2in13_V4.EPD() #初始化
epd.init()#设定屏幕刷新模式
#epd.Clear(0xFF) #清除屏幕内容
##################屏幕初始化#########################
logging.info("Width = %s, Height = %s", format(epd.width), format(epd.height)) #打印屏幕高度及宽度
logging.info("Initialize and clear the display")#屏幕开始准备相关展示
info_image = Image.new('1', (epd.height, epd.width), 255) #画布创建准备
draw = ImageDraw.Draw(info_image)
Basic_refresh() #全局刷新
Partial_refresh() #局部刷新
epd.init()
epd.Clear(0xFF)
epd.sleep()
except IOError as e:
logging.info(e)
except KeyboardInterrupt:
logging.info("Keyboard interrupt detected, exiting gracefully.")
epd.init()
epd.Clear(0xFF) # 清除屏幕内容
epd.sleep() # 使屏幕进入休眠状态
epd2in13_V4.epdconfig.module_exit() # 清理资源
exit()
except Exception as e:
logging.error("An unexpected error occurred: %s", e)
epd.init()
epd.Clear(0xFF) # 清除屏幕内容
epd.sleep() # 使屏幕进入休眠状态
epd2in13_V4.epdconfig.module_exit() # 清理资源
exit()
# 脚本正常结束后的清理操作
epd.init()
epd.Clear(0xFF) # 清除屏幕内容
epd.sleep() # 使屏幕进入休眠状态
epd2in13_V4.epdconfig.module_exit() # 清理资源
exit()

View File

@@ -7,7 +7,7 @@ if [ "$EUID" -ne 0 ]; then
fi
# 默认语言环境
DEFAULT_LANG="en_US.UTF-8"
DEFAULT_LANG="en_GB.UTF-8"
# 检查是否使用中国镜像源
USE_CN_MIRROR=false
# 控制调试输出
@@ -37,6 +37,14 @@ while [ "$#" -gt 0 ]; do
--pisugar-power-manager)
USE_PISUGAR_POWER_MANAGER=true
;;
--version)
if [ -z "$2" ]; then
echo "错误: --version 参数后需要跟版本号"
exit 1
fi
VERSION="$2" # 将版本号赋值给变量 VERSION
shift 2 # 移动参数,跳过版本号参数及其值
;;
--debug)
DEBUG=true
;;
@@ -134,10 +142,10 @@ if [ "$USE_CN_MIRROR" = true ]; then
fi
# 定义仓库链接变量
INK_SCREEN_CLOCK_REPO_URL="https://github.com/kxgx/2.13-Ink-screen-clock.git"
INK_SCREEN_CLOCK_REPO_URL="https://github.com/kxgx/2.13-Ink-screen-clock"
# 如果使用中国仓库,则更新链接变量
if [ "$USE_CN_GIT" = true ]; then
INK_SCREEN_CLOCK_REPO_URL="https://gitee.com/xingguangk/2.13-Ink-screen-clock.git"
INK_SCREEN_CLOCK_REPO_URL="https://gitee.com/xingguangk/2.13-Ink-screen-clock"
fi
# 更新源列表函数
@@ -198,7 +206,7 @@ install_packages() {
exit 1
fi
echo "正在安装软件包"
if ! sudo apt-get -q -y install git pigpio i2c-tools netcat* gawk python3-dev python3-pip python3-pil python3-numpy python3-gpiozero python3-pigpio build-essential; then
if ! sudo apt-get -q -y install git pigpio i2c-tools netcat* gawk python3-dev python3-pip python3-pil python3-numpy python3-gpiozero python3-pigpio build-essential screen; then
echo "软件包安装失败" >&2
exit 1
fi
@@ -225,7 +233,7 @@ setup_service() {
if [ ! -d "$HOME/2.13-Ink-screen-clock" ]; then
echo "正在克隆仓库"
cd ~
if ! git clone $INK_SCREEN_CLOCK_REPO_URL; then
if ! git clone -b $VERSION $INK_SCREEN_CLOCK_REPO_URL; then
echo "克隆仓库失败" >&2
exit 1
fi

View File

@@ -10,7 +10,7 @@ from threading import Timer
import requests
white = 255 #颜色
black = 0
logging.basicConfig(level=logging.DEBUG)
logging.basicConfig(level=logging.INFO)
################################引入配置文件开始################################################
picdir = os.path.join(os.path.dirname(os.path.dirname(os.path.realpath(__file__))), 'pic')
libdir = os.path.join(os.path.dirname(os.path.dirname(os.path.realpath(__file__))), 'lib')
@@ -30,24 +30,6 @@ def Local_strong_brush(): #局部强制刷新显示
while i < 5:
epd.displayPartial(epd.getbuffer(info_image.rotate(180)))#局刷开始
i = i + 1
def getWeath(city='101060111'): #天气函数,下载json天气至本地
headers = {
'User-Agent':'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/131.0.0.0 Safari/537.36',
'Referer':'http://www.weather.com.cn/'
}
response = requests.get('http://d1.weather.com.cn/sk_2d/'+city+'.html',headers=headers)
response.encoding = 'utf-8'
Weath=response.text[11:]
fileHandle=open('weather.json','w')
fileHandle.write(str(Weath))
fileHandle.close()
Timer(1800, getWeath).start() #定时器函数,间隔三分钟下载文件至本地
print("天气文件更新")
def gey_yiyan(): #一言API
response = requests.get("https://international.v1.hitokoto.cn/?c=k&c=f&c=d&c=a&encode=text&min_length=7&max_length=19")
response.encoding = 'utf-8'
yiyan=response.text
return yiyan
def get_date():#返回当前年月日及星期几
date = datetime.datetime.now()
today=LunarDate.today()
@@ -84,11 +66,6 @@ def Bottom_edge(): #在图片中添加底边内容
power_str=power_battery()
draw.text((128,108),power_str,font = font04,fill =255) #显示当前电量百分比
'''电池图标画图'''
'''添加一言API'''
global Time_keeping
Time_keeping =0
draw.text((4,84),gey_yiyan(),font = font06,fill =0)
'''添加一言API end'''
draw.ellipse((192, 107, 207, 120), 0, 255)# 时钟图标
draw.line((199,109,199,114),fill=255, width=1)
draw.line((200,114,204,114),fill=255, width=1)
@@ -216,23 +193,8 @@ def Partial_refresh():#局刷函数
power_str=power_str1
Local_strong_brush() #局部强刷
logging.info("电源电量局部刷新")
'''一言API显示'''
global Time_keeping
Time_keeping+=1
if Time_keeping == 300 : #一言API局刷,当变量Time_keeping数据为10即开始执行
draw.rectangle((1, 82, 248, 101), fill = 255)
draw.text((4,84),gey_yiyan(),font = font06,fill =0)
Time_keeping=0
Local_strong_brush() #局部强刷
logging.info("一言API局部刷新")
'''一言API显示'''
#epd.displayPartial(epd.getbuffer(info_image.rotate(180)))#局刷开始
time.sleep(2)
#if time.strftime('%H%M%S')=='000000': #如果时间是晚上00点,执行全局刷新
#Partial_full_brush() #每天全局刷新一次
try:
##################屏幕初始化#########################
getWeath()#天气获取函数开始运行
epd = epd2in13_V4.EPD() #初始化
epd.init()#设定屏幕刷新模式
#epd.Clear(0xFF) #清除屏幕内容
@@ -269,4 +231,4 @@ epd.init()
epd.Clear(0xFF) # 清除屏幕内容
epd.sleep() # 使屏幕进入休眠状态
epd2in13_V4.epdconfig.module_exit() # 清理资源
exit()
exit()

View File

@@ -1,10 +1,14 @@
#!/bin/bash
f_name=main.py
f1_name=wenter.py
dir=$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )
logdir=${dir%/*}
logdir="${dir%/*}/log"
# 确保日志目录存在
mkdir -p "${logdir}"
pid=`ps -ef |grep $dir/$f_name | grep -v grep |awk '{print $2}'`
for id in $pid
do
kill -9 $id
done
nohup /usr/bin/python3 -u $dir/$f_name > $logdir/log/info.log 2>&1 &
nohup /usr/bin/python3 -u $dir/$f_name > $logdir/info.log 2>&1 &
nohup /usr/bin/python3 -u $dir/$f1_name > $logdir/info-wenter.log 2>&1 &

42
bin/wenter.py Normal file
View File

@@ -0,0 +1,42 @@
#!/usr/bin/env python
# -*- coding:utf-8 -*-
import os,sys,re,json,time,datetime #引入系统相关库
import logging #日志库
import subprocess
import os
from threading import Timer
import requests
white = 255 #颜色
black = 0
logging.basicConfig(level=logging.INFO)
################################引入配置文件开始################################################
picdir = os.path.join(os.path.dirname(os.path.dirname(os.path.realpath(__file__))), 'pic')
libdir = os.path.join(os.path.dirname(os.path.dirname(os.path.realpath(__file__))), 'lib')
if os.path.exists(libdir):
sys.path.append(libdir)#将引入文件添加到环境变量
def getWeath(city='101060111'): #天气函数,下载json天气至本地
headers = {
'User-Agent':'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/131.0.0.0 Safari/537.36',
'Referer':'http://www.weather.com.cn/'
}
response = requests.get('http://d1.weather.com.cn/sk_2d/'+city+'.html',headers=headers)
response.encoding = 'utf-8'
Weath=response.text[11:]
fileHandle=open('weather.json','w')
fileHandle.write(str(Weath))
fileHandle.close()
Timer(180, getWeath).start() #定时器函数,间隔三分钟下载文件至本地
print("天气文件更新")
try:
getWeath()#天气获取函数开始运行
except IOError as e:
logging.info(e)
except KeyboardInterrupt:
logging.info("Keyboard interrupt detected, exiting gracefully.")
except Exception as e:
logging.error("An unexpected error occurred: %s", e)
exit()
# 脚本正常结束后的清理操作
exit()